package com.testor.module.contractor.manage.controller;

import java.util.ArrayList;
import java.util.List;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.testor.module.contractor.manage.model.domain.TContractorAllowPerson;
import com.testor.module.contractor.manage.model.vo.TContractorAllowProtectiveVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import lombok.extern.slf4j.Slf4j;
import com.tongtech.tfw.backend.core.helper.StringHelper;
import com.tongtech.tfw.backend.core.helper.ObjectHelper;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tongtech.tfw.backend.common.biz.constants.BizConstants;
import com.tongtech.tfw.backend.common.biz.models.BaseResponse;
import com.tongtech.tfw.backend.common.biz.models.BaseResponseList;
import com.tongtech.tfw.backend.common.biz.models.BizGeneralResponse;
import com.tongtech.tfw.backend.common.models.supers.SuperController;
import com.tongtech.tfw.backend.core.helper.IdHelper;
import com.tongtech.tfw.backend.core.helper.TypeHelper;
import com.tongtech.tfw.backend.core.helper.bean.BeanHelper;

import com.testor.module.contractor.manage.model.domain.TContractorAllowProtective;
import com.testor.module.contractor.manage.model.dto.TContractorAllowProtectiveParam;
import com.testor.module.contractor.manage.model.dto.TContractorAllowProtectiveDelParam;
import com.testor.module.contractor.manage.service.TContractorAllowProtectiveService;

/**
 * 准入信息-防护用品台账关联Controller
 *
 * @author testor-framework
 * @date 2024-11-26 14:08:58
 */
@RestController
@RequestMapping("/protective/protective")
@Api(value = "TContractorAllowProtective", tags = "准入信息-防护用品台账关联")
@Slf4j
public class TContractorAllowProtectiveController extends SuperController
{
    @Autowired
    private TContractorAllowProtectiveService tContractorAllowProtectiveService;

    /* Generated Method*/
	@ApiOperation(value = "新增 准入信息-防护用品台账关联", notes = "Add TContractorAllowProtective")
	@PostMapping(value = "/add")
	public BaseResponse<TContractorAllowProtective>addEntity(@RequestBody TContractorAllowProtectiveParam addRequest) {
		BaseResponse<TContractorAllowProtective> baseResponse=new BaseResponse<>();
		if(ObjectHelper.isNotEmpty(addRequest)){
			tContractorAllowProtectiveService.remove(new LambdaQueryWrapper<TContractorAllowProtective>().eq(TContractorAllowProtective::getAllowId, addRequest.getAllowId()));
			List<String> ids = addRequest.getIds();
			for (String id : ids) {
				TContractorAllowProtective data = BeanHelper.beanToBean(addRequest, TContractorAllowProtective.class);
				data.setId(IdHelper.getId32bit());
				data.setProtectiveId(id);
				tContractorAllowProtectiveService.save(data);
			}
		}
		return baseResponse;
	}

	@ApiOperation(value = "获取 准入信息-防护用品台账关联 ", notes = "Get TContractorAllowProtective By Id")
	@GetMapping(value = "/get")
	public BaseResponse<TContractorAllowProtective> getById(String id){
		BaseResponse<TContractorAllowProtective> baseResponse=new BaseResponse<>();
		if(StringHelper.isNotEmpty(id)){
			// TODO 按需求添加业务异常判断
            TContractorAllowProtective data= tContractorAllowProtectiveService.getById(id);
			baseResponse.setData(data);
		}
		return baseResponse;
	}

	@ApiOperation(value = "修改 准入信息-防护用品台账关联 ", notes = "Update TContractorAllowProtective By Id")
	@PutMapping(value = "/update")
	public BaseResponse<BizGeneralResponse> updateEntity(@RequestBody TContractorAllowProtective updateRequest){
		BaseResponse<BizGeneralResponse> baseResponse=new BaseResponse<>();
		if(ObjectHelper.isNotEmpty(updateRequest)&&StringHelper.isNotEmpty(updateRequest.getId())){
			// TODO 按需求添加数据去重，特殊值设定，业务异常
            TContractorAllowProtective data=BeanHelper.beanToBean(updateRequest, TContractorAllowProtective.class);
			boolean result= tContractorAllowProtectiveService.updateById(data);
			baseResponse.setData(
					BizGeneralResponse.builder().result(TypeHelper.castToString(result)).build());
		}
		return baseResponse;
	}

	@ApiOperation(value = "删除 准入信息-防护用品台账关联 ", notes = "delete TContractorAllowProtective By Id")
	@PutMapping(value = "/delete")
	public BaseResponse<BizGeneralResponse> deleteEntity(@RequestBody TContractorAllowProtectiveDelParam deleteRequest){
		BaseResponse<BizGeneralResponse> baseResponse=new BaseResponse<>();
		if(ObjectHelper.isNotEmpty(deleteRequest)&&StringHelper.isNotEmpty(deleteRequest.getId())){
			// TODO 按需求添加数据去重，特殊值设定，业务异常
            TContractorAllowProtective data= new TContractorAllowProtective();
			data.setId(deleteRequest.getId());
			data.setStatus(BizConstants.STATUS_DELETE);
			boolean result= tContractorAllowProtectiveService.updateById(data);
			baseResponse.setData(
					BizGeneralResponse.builder().result(TypeHelper.castToString(result)).build());
		}
		return baseResponse;
	}

	@ApiOperation(value = "批量删除准入信息-防护用品台账关联", notes = "delete TContractorAllowProtective by batch Id")
	@PutMapping(value = "/batch_delete")
	public BaseResponse<BizGeneralResponse> deleteEntityBatch(
			@RequestBody TContractorAllowProtectiveDelParam deleteRequest) {
		BaseResponse<BizGeneralResponse> baseResponse = new BaseResponse<>();
		if (ObjectHelper.isNotEmpty(deleteRequest) && (!deleteRequest.getIds().isEmpty())) {
            /* 批量删除 */
			List<TContractorAllowProtective> tContractorAllowProtectiveList = new ArrayList<>();
            for(String id: deleteRequest.getIds()){
                TContractorAllowProtective data= new TContractorAllowProtective();
				data.setId(id);
				data.setStatus(BizConstants.STATUS_DELETE);
                tContractorAllowProtectiveList.add(data);
			}
			boolean result = tContractorAllowProtectiveService.updateBatchById(tContractorAllowProtectiveList);
			baseResponse.setData(
					BizGeneralResponse.builder().result(TypeHelper.castToString(result)).build());
		}
		return baseResponse;
	}

	@ApiOperation(value = "获取 准入信息-防护用品台账关联 分页列表", notes = "List TContractorAllowProtective with page")
	@GetMapping(value = "/list")
	public  BaseResponse<BaseResponseList<TContractorAllowProtectiveVo>>listEntity(TContractorAllowProtectiveParam param){
		BaseResponse<BaseResponseList<TContractorAllowProtectiveVo>>baseResponse=new BaseResponse<>();
		Page<TContractorAllowProtectiveVo> resultList= tContractorAllowProtectiveService.listEntity(param);
		BaseResponseList<TContractorAllowProtectiveVo> baseResponseList=new BaseResponseList<>();
		baseResponseList.setData(resultList.getRecords());
		baseResponseList.setTotal(resultList.getTotal());
		baseResponse.setData(baseResponseList);
		return baseResponse;
	}

	@ApiOperation(value = "获取 准入信息-防护用品台账关联 列表", notes = "List TContractorAllowProtective all")
	@GetMapping(value = "/datas")
	public  BaseResponse<BaseResponseList<TContractorAllowProtective>>listAllEntity(TContractorAllowProtectiveParam param){
		BaseResponse<BaseResponseList<TContractorAllowProtective>>baseResponse=new BaseResponse<>();
		List<TContractorAllowProtective> resultList=tContractorAllowProtectiveService.listAllEntity(param);
		BaseResponseList<TContractorAllowProtective> baseResponseList=new BaseResponseList<>();
		baseResponseList.setData(resultList);
		baseResponseList.setTotal(resultList.size());
		baseResponse.setData(baseResponseList);
		return baseResponse;
	}


}
